=== debian/changelog ===
ros-noetic-openzen-sensor (1.2.0-1buster) buster; urgency=high

  * fixed conditions check for build or download OpenZen options
  * fixed name of primary maintainer
  * added install target for openzen_node
  * manually setting component ID in case a TestSensor is used
  * running rostest as part of the catkin CMake file
  * switched binary downloads to OpenZen 1.2.0
  * updated OpenZen to version 1.2.0
  * added output of GNSS measurement as ROS NavSatFix message
  * Contributors:

 -- Thomas Hauth <thomas@lp-research.com>  Mon, 16 Nov 2020 15:00:00 -0000

ros-noetic-openzen-sensor (1.0.1-1buster) buster; urgency=high

  * changed OpenZen version to release 1.1.3
  * added option to select binary download and disabled binary downloads by default
  * updated to OpenZen 1.1.2 for ARM64
  * updated OpenZen version to support LPMS-BE1
  * added support for ARM64 binary
  * checking if environment is modern enough to build OpenZen, otherwise download binary release
  * added licenses of OpenZen and its dependencies
  * added License header to source files
  * added License file
  * Contributors: LP-Research Inc. Team

 -- Thomas Hauth <thomas@lp-research.com>  Wed, 02 Sep 2020 15:00:00 -0000

ros-noetic-openzen-sensor (1.0.0-1buster) buster; urgency=high

  * Initial Release of OpenZen ROS driver
  * Contributors: LP-Research Inc. Team

 -- Thomas Hauth <thomas@lp-research.com>  Sun, 12 Apr 2020 15:00:00 -0000
